//+--------------------------------------------------+
//|                                          JMA.mq4 |
//|                      Flat Eric's Monkey business |
//+--------------------------------------------------+
#property copyright "Copyright  2006, Flat Eric's Monkey business"

#property indicator_chart_window
#property indicator_buffers 6
#property indicator_color1 Orange
#property indicator_color2 Yellow
#property indicator_color3 Aqua
#property indicator_color4 Red
#property indicator_color5 Aqua
#property indicator_color6 Red

//---- input parameters
extern double    Grad=1;

//---- buffers
double jmabuffer[];
double fatbuffer[];
double fatupsig[];
double fatdownsig[];
double jmaupsig[];
double jmadownsig[];
//---- Globals
datetime  prevtime;
int handle;
bool lng=false;
bool shrt=false;
double fatprice,fatpriceold,fatgrad,jmaold;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
   SetIndexStyle(0,DRAW_LINE,STYLE_SOLID,2);
   SetIndexStyle(1,DRAW_LINE,STYLE_SOLID,2);
   SetIndexStyle(2,DRAW_LINE,STYLE_SOLID,2);
   SetIndexStyle(3,DRAW_LINE,STYLE_SOLID,2);
   SetIndexStyle(4,DRAW_LINE,STYLE_SOLID,2);
   SetIndexStyle(5,DRAW_LINE,STYLE_SOLID,2);
   SetIndexBuffer(0,jmabuffer);
   SetIndexBuffer(1,fatbuffer);
   SetIndexBuffer(2,fatupsig);
   SetIndexBuffer(3,fatdownsig);
   SetIndexBuffer(4,jmaupsig);
   SetIndexBuffer(5,jmadownsig);
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//---- 
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   int i;
   int    counted_bars=IndicatorCounted();
//---- 
string rogstr;
bool firstTime=True;
int AccountedBars=0;
double bug;

int shift=0;
int samples;
int result;

   int fshift=0,fcnt=0;
   double fatprice=0,fAccountedBars=0;
   int    fcounted_bars=IndicatorCounted();

if (firstTime)
{
  AccountedBars = Bars-40;
  firstTime=False;
}

if (Time[0]==prevtime) return(0); 
prevtime=Time[0];

for (shift=40; shift>=0; shift--){

fatprice = 
0.4360409450*Close[shift+0]
+0.3658689069*Close[shift+1]
+0.2460452079*Close[shift+2]
+0.1104506886*Close[shift+3]
-0.0054034585*Close[shift+4]
-0.0760367731*Close[shift+5]
-0.0933058722*Close[shift+6]
-0.0670110374*Close[shift+7]
-0.0190795053*Close[shift+8]
+0.0259609206*Close[shift+9]
+0.0502044896*Close[shift+10]
+0.0477818607*Close[shift+11]
+0.0249252327*Close[shift+12]
-0.0047706151*Close[shift+13]
-0.0272432537*Close[shift+14]
-0.0338917071*Close[shift+15]
-0.0244141482*Close[shift+16]
-0.0055774838*Close[shift+17]
+0.0128149838*Close[shift+18]
+0.0226522218*Close[shift+19]
+0.0208778257*Close[shift+20]
+0.0100299086*Close[shift+21]
-0.0036771622*Close[shift+22]
-0.0136744850*Close[shift+23]
-0.0160483392*Close[shift+24]
-0.0108597376*Close[shift+25]
-0.0016060704*Close[shift+26]
+0.0069480557*Close[shift+27]
+0.0110573605*Close[shift+28]
+0.0095711419*Close[shift+29]
+0.0040444064*Close[shift+30]
-0.0023824623*Close[shift+31]
-0.0067093714*Close[shift+32]
-0.0072003400*Close[shift+33]
-0.0047717710*Close[shift+34]
+0.0005541115*Close[shift+35]
+0.0007860160*Close[shift+36]
+0.0130129076*Close[shift+37]
+0.0040364019*Close[shift+38];

   fatbuffer[shift]= EMPTY_VALUE;
   if (fatprice > fatpriceold && fatprice - fatpriceold >Grad*Point){
      fatupsig[shift]=fatprice;
      fatdownsig[shift]=EMPTY_VALUE;
//      fatbuffer[shift]= EMPTY_VALUE;
   }
   if (fatprice < fatpriceold && fatprice - fatpriceold <-Grad*Point){
      fatdownsig[shift]=fatprice;
      fatupsig[shift]=EMPTY_VALUE;
//      fatbuffer[shift]= EMPTY_VALUE;
   }
//Comment("Fatgrad= ",fatprice - fatpriceold);
fatpriceold=fatprice;

  if (shift>0)
  { 
    AccountedBars=AccountedBars+1;
  }

}     // End of JMA

//Comment("Fatgrad= ",fatprice - fatpriceold,"   ","JMA= ",jma1);

  
//----
   return(0);
  }
//+------------------------------------------------------------------+